data asped;
input Y R G F;
if (G > 24) then new = 0; else new = 1;
if (new) then Gn = 999; else Gn = G;
datalines;
2   1   25   1
4   1   25   2
6   1   25   3
1   1   26   1
3   1   26   2
5   1   26   3
9   1   27   1
9   1   27   2
8   1   27   3
9   1   28   1
9   1   28   2
7   1   28   3
2   1    1   1
5   1    1   2
7   1    1   3
3   1    2   1
6   1    2   2
5   1    2   3
4   1    3   1
7   1    3   2
6   1    3   3
5   1    4   1
8   1    4   2
4   1    4   3
6   1    5   1
8   1    5   2
8   1    5   3
7   1    6   1
8   1    6   2
7   1    6   3
3   2   25   1
3   2   25   2
7   2   25   3
2   2   26   1
2   2   26   2
4   2   26   3
8   2   27   1
8   2   27   2
8   2   27   3
7   2   28   1
8   2   28   2
9   2   28   3
1   2    7   1
2   2    7   2
3   2    7   3
2   2    8   1
3   2    8   2
5   2    8   3
3   2    9   1
4   2    9   2
4   2    9   3
4   2   10   1
4   2   10   2
5   2   10   3
8   2   11   1
8   2   11   2
8   2   11   3
3   2   12   1
5   2   12   2
7   2   12   3
4   3   25   1
6   3   25   2
8   3   25   3
2   3   26   1
5   3   26   2
7   3   26   3
8   3   27   1
7   3   27   2
9   3   27   3
7   3   28   1
7   3   28   2
9   3   28   3
7   3   13   1
7   3   13   2
9   3   13   3
5   3   14   1
6   3   14   2
8   3   14   3
3   3   15   1
5   3   15   2
6   3   15   3
7   3   16   1
7   3   16   2
9   3   16   3
6   3   17   1
8   3   17   2
8   3   17   3
5   3   18   1
7   3   18   2
8   3   18   3
4   4   25   1
5   4   25   2
6   4   25   3
5   4   26   1
2   4   26   2
5   4   26   3
9   4   27   1
9   4   27   2
9   4   27   3
9   4   28   1
8   4   28   2
7   4   28   3
5   4   19   1
8   4   19   2
9   4   19   3
6   4   20   1
6   4   20   2
8   4   20   3
7   4   21   1
4   4   21   2
8   4   21   3
8   4   22   1
7   4   22   2
9   4   22   3
9   4   23   1
8   4   23   2
9   4   23   3
9   4   24   1
8   4   24   2
9   4   24   3
;

ods trace on;
proc glm data = asped;
class R G F;
model Y = R G R*G F F*G/solution ;
lsmeans F G  F*G/ out= solution noprint;
ods output parameterestimates = aspedparameterestimates;
run;
/*Only G check means and check by F means are estimable*/
ods trace off;
proc sort data = aspedparameterestimates;
  By descending Estimate ;
proc print; run;

ods listing close;      /*Allows unordered solutions to not be printed.*/
ods trace on;
proc mixed data = asped;
  class R F G Gn;
  model Y = F Gn F*Gn/solution;
  random R R*Gn G*new/solution;
  lsmeans Gn F F*Gn;
ods output solutionr = solutionforrandomeffects;
ods output lsmeans =leastsquaresmeans;
run;
ods trace off;
ods listing;            /* End of no printing statement of solutions.*/
 proc sort data = solutionforrandomeffects;
   By descending Estimate;
Proc print; run;
proc sort data = leastsquaresmeans;
  By descending Estimate;
proc print; run;
