data asbed;
input Y R A B;
IF (A>9) THEN NEWA = 0; ELSE NEWA = 1;
IF (NEWA) THEN AN = 99; ELSE AN = A;
IF (B>6) THEN NEWB = 0; ELSE NEWB = 1;
IF (NEWB) THEN BN = 999; ELSE BN = B;
 /*This part treats the new treatments s randon effects.*/
/*R is replicate, A is factor A treatment, B is factor B treatment,
Y is response*/
datalines;
9   1   1   1
2   1   1   2
8   1   1   7
7   1   1   8
5   1   1   9
9   1   2   1
7   1   2   2
3   1   2   7
5   1   2   8
4   1   2   9
9   1   3   1
2   1   3   2
8   1   3   7
7   1   3   8
5   1   3   9
9   1  10   1
1   1  10   2
9   1  10   7
7   1  10   8
5   1  10   9
9   1  11   1
7   1  11   2
3   1  11   7
5   1  11   8
4   1  11   9
9   1  12   1
2   1  12   2
8   1  12   7
7   1  12   8
5   1  12   9
9   1  13   1
7   1  13   2
3   1  13   7
5   1  13   8
4   1  13   9
9   2   4   3
7   2   4   4
13  2   4   7
8   2   4   8
8   2   4   9
9   2   5   3
12  2   5   4
8   2   5   7
7   2   5   8
8   2   5   9
9   2   6   3
7   2   6   4
13  2   6   7
9   2   6   8
12  2   6   9
9   2  10   3
11  2  10   4
9   2  10   7
7   2  10   8
5   2  10   9
9   2  11   3
7   2  11   4
13  2  11   7
5   2  11   8
4   2  11   9
9   2  12   3
12  2  12   4
8   2  12   7
7   2  12   8
5   2  12   9
9   2  13   3
7   2  13   4
13  2  13   7
5   2  13   8
4   2  13   9
19  3   7   5
17  3   7   6
13  3   7   7
15  3   7   8
14  3   7   9
19  3   8   5
12  3   8   6
18  3   8   7
17  3   8   8
45  3   8   9
19  3   9   5
17  3   9   6
13  3   9   7
25  3   9   8
34  3   9   9
15  3  10   5
 9  3  10   6
11  3  10   7
10  3  10   8
10  3  10   9
 9  3  11   5
17  3  11   6
13  3  11   7
15  3  11   8
14  3  11   9
 9  3  12   5
12  3  12   6
 8  3  12   7
17  3  12   8
15  3  12   9
 9  3  13   5
17  3  13   6
13  3  13   7
15  3  13   8
14  3  13   9
 ; RUN;

/*ANOVA AND LSMEANS FOR DATA ASBED*/

PROC GLM DATA = asbed;
 CLASS R A B;
 MODEL Y = R A R*A B B*R A*B A*B*R;
 LSMEANS  A B;
RUN;

/*ANOVA AND LSMEANS FOR CHECKS ONLY*/

PROC GLM DATA = work.asbed;
CLASS R A B AN BN;
MODEL Y = R AN AN*R BN BN*R AN*BN AN*BN*R;
LSMEANS AN  BN AN*BN;
RUN;


PROC MIXED DATA = work.asbed;
 CLASS R A B BN AN ;
 MODEL Y = AN BN AN*BN/SOLUTION;
 RANDOM R A*NEWA B*NEWB/SOLUTION;
 LSMEANS AN BN AN*BN;
 MAKE 'SOLUTIONR' OUT = sr;
 RUN;
 PROC SORT DATA = sr;
  BY DESCENDING estimate;
RUN;
PROC PRINT; RUN;

QUIT;
